<!DOCTYPE html>
<html>

<head>
    <title>INF226</title>
    <link rel="stylesheet" href="highlight.css" />
	<link rel="icon" href="favicon.png" type="image/png" />

    <style>
        * {
            box-sizing: border-box;
            ;
        }

        #page {
            height: 100vh;
            display: flex;
            flex-direction: column;
            ;
            padding: .5rem;
        }

        main {
            border-top: 1px solid grey;
            border-bottom: 1px solid grey;
            /* min-height: 50%; */
            flex-grow: 1;
            flex-shrink: 1;
            overflow:auto;
        }

        body {
            margin: 0;
        }

        label {
            justify-self: end;
            ;
        }

        #controls {
            /* min-height: 20%; */
            font-size: 1.4rem;
            display: grid;
            grid-template-columns: 1fr 6fr 1fr 1fr;
            grid-auto-rows: 1.4rem;
            ;
            grid-gap: .5rem;
            max-width: 70rem;

        }

        #output {
            width: 100%;
            height: 100%;
            background: #eee;
            overflow: auto;
            margin: 0;
        }
        #output p {
            border-bottom: 1px solid grey;
            padding-bottom: .25rem;
        }
        #header {
            display: flex;
            flex-direction: row;
            flex-wrap: wrap;
        }

        #header li {
            display: block;
            font-style: italic;
            font-size: 1.2rem;
            padding: .25rem;
            margin:0 1rem;
        }
    </style>

</head>

<body onload="onload()">
    <div id="page">
        <marquee>
            <div id="header"></div>
        </marquee>
        <main>
            <pre id="output"></pre>
        </main>
        <div id="controls">
            <label for="search">Search:</label>
            <input type="search" id="search" name="search" enterkeyhint="search" value="*">
            <button type="button" id="searchBtn">Search!</button>
            <button id="logoutBtn">Logout</button>
            <label for="recipient">To:</label>
            <input type="text" id="recipient" name="recipient" value="">
            <button type="button" id="sendBtn">Send</button>
            <span></span>
            <label for="message">Message:</label>
            <textarea id="message" style="grid-row: span 4;">A message...</textarea>
        </div>
        <div id="anchor"></div>

        <div id="info">
            <p id="loginInfo"></p>
        </div>
    </div>
</body>
<script>
    var reqId = 0;
    var anchor = document.getElementById('anchor');
    var searchField = document.getElementById('search');
    var recipientField = document.getElementById('recipient');
    var messageField = document.getElementById('message');
    var searchBtn = document.getElementById('searchBtn');
    var logoutBtn = document.getElementById('logoutBtn');
    var sendBtn = document.getElementById('sendBtn');
    var allBtn = document.getElementById('allBtn');
    var output = document.getElementById('output');
    var header = document.getElementById('header');
    var loginInfo = document.getElementById('loginInfo');

    var messageCount = 0;

    var onload = async () => {
        const q = `/loginInfo`;
        res = await fetch(q, { method: 'post' });
        user = await res.text();
        loginInfo.innerHTML = "Logged in as: " + user;
        update();
    }

    var checkAnnouncements = async () => {
        res = await fetch('/announcements');
        anns = await res.json();
        if (anns && Array.isArray(anns.data)) {
            const elts = [];
            anns.data.forEach((element, idx) => {
                if (idx > 0) {
                    const node = document.createElement('li');
                    node.textContent = '  …  ';
                    elts.push(node);
                }
                const node = document.createElement('li');
                node.textContent = `${element.message || ''}`;
                elts.push(node);
            });
            console.log(elts);
            header.replaceChildren(...elts);
        }
    };
    var search = async (query) => {
        const id = reqId++;
        const q = `/search?q=${encodeURIComponent(query)}`;
        res = await fetch(q);
        text = await res.text();
        text = text.split("\n");

        for (let i = 0; i < output.children.length-1; i++) {
            output.children[i].style.backgroundColor = "#eee";
        }

        if (text.length-1 < messageCount){
            console.log(text.length);
            console.log(text);
            for (let i = 0; i < text.length-1; i++) {
                message = JSON.parse(text[i]);
                head = document.getElementById(message[0]);
                head.style.backgroundColor = "#ff000099";
                head.scrollIntoView({block: "end", inline: "nearest", behavior: "smooth"});
                anchor.scrollIntoView();
            }
        }
    };
    var update = async () => {
        const q = `/update`;
        res = await fetch(q);
        console.log(res);
        text = await res.text();
        text = text.split("\n");
        if (text.length > messageCount) {
            messageCount = text.length;
            output.innerHTML = "";
            for (let i = 0; i < text.length-1; i++) {
                message = JSON.parse(text[i]);
                if (message[2] == "") {
                    message[2] = "All";
                }
                const head = document.createElement('h3');
                head.setAttribute("id", message[0]);
                head.textContent = `${message[1]} → ${message[2]} | Sent At: ${message[3]}`;
                output.appendChild(head);
                const body = document.createElement('p');
                body.innerHTML = message[4];
                output.appendChild(body)
                body.scrollIntoView({block: "end", inline: "nearest", behavior: "smooth"});
                anchor.scrollIntoView();
            }   
        }

        checkAnnouncements();
    }
    var send = async (recipient, message) => {
        const id = reqId++;
        const q = `/send?recipient=${encodeURIComponent(recipient)}&message=${encodeURIComponent(message)}`;
        res = await fetch(q, { method: 'post' });
        text = await res.text();
        text = text.split(';')
        console.log(res);
        const head = document.createElement('h3');
        head.setAttribute("id", text[0]);
        if (recipient == "") {
            recipient = "all";  
        }
        head.textContent = `${user} → ${recipient} | Sent At: ${text[1]}`;
        output.appendChild(head);
        const body = document.createElement('p');
        body.innerHTML = text[0];
        output.appendChild(body);
        messageCount++;
        body.scrollIntoView({block: "end", inline: "nearest", behavior: "smooth"});
        anchor.scrollIntoView();
        checkAnnouncements();
    };

    var logout = async () => {
        const q = `/logout`;
        res = await fetch(q, { method: 'post' });
        if (res) {
            location.reload()
        }
    };

    searchField.addEventListener('keydown', ev => {
        if (ev.key === 'Enter') {
            search(searchField.value);
        }
    });
    setInterval(update, 5000);
    searchBtn.addEventListener('click', () => search(searchField.value));
    sendBtn.addEventListener('click', () => send(recipientField.value, messageField.value));
    logoutBtn.addEventListener('click', () => logout());
    checkAnnouncements();
</script>

</html>